# SQ Database Namespace
* A namespace with components designed for SQDB
* Requires the use of Orc.js 
* Communication with database is done through a dedicated worker from Orc.js
* Update is done through polling. 
* Awaiting support for websockets.

## Components

### Table
* The Sqdb Table is a reflection of a table in the database

``` html
 <sqdb:table 
    url="http://devapps.sqreem.com:50000/data" 
    database="tracker"
    table="task">
  </sqdb:table>
```

### Form


### Query 
* Query is a component that uses its contents to make a query
* It makes a query on load 
* When contenteditable is set to true, queries are made when its contents are changed

``` html
  <sqdb:query url="http://devapps.sqreem.com:50000/data" contenteditable="true" > 
        { "connection": 
            { "database": "tracker", 
              "credentials": { "username": "sa", "password": "sa" }
            },
            "table": "task",
            "loadFields": true,
            "filter": {
                "operator": "and",
                "criteria": [
                 {
                  "field": "application",
                  "value": "Tile2"
                 }
                ]
            }
        }
    </sqdb:query>
```