{
    const Form = sq.newComponent('sqdb:form')
    Form.prototype.init = function () {
        const me = this;
        me.__proto__.__proto__.init.call(me)
        me._record = {}
        me._fields = {}
        me.json = {
            "connection": {
                "database": null,
                "credentials": {
                    "username": "sa",
                    "password": "sa"
                }
            },
            'table': null,
            'loadFields': true,
            "loadMetaData": [
                "tableInfo",
                "fileInfo"
            ]
        }
        me.serviceUrl = null
    }

    Form.prototype.load = function () {
        const me = this
        const sqdb = me.namespace
        me.__proto__.__proto__.load.call(me)
        me.id = me.dom.querySelector(".id")
        me.repeatDom = me.dom.querySelector('.repeaterDom')
        me.dom.children.getdata.onclick = function () {
            let x = me.getRecord()
            console.log(x)
        }
        me.dom.children.resetcont.onclick = function () {
            sqdb.orc.getFields(me.serviceUrl, me.json).then(function (resp) {
                console.log("GETFIELDS", resp)
                me.context(resp)
            })
        }
        me.dom.children.submit.onclick = function () {
            let x = me.getRecord()
            me.submit(x);
        }
        sqdb.orc.post('getDataTypes').then(()=>{
            sqdb.orc.post("getFields", [me.serviceUrl, me.json]).then(function (resp) {
                console.log("GETFIELDS", resp)
                me.context(resp)
            })
        })
        
    }
    Form.prototype.submit = function (data) {
        const me = this
        const sqdb = me.namespace
        me.json.method="insert"
        me.json.data=data
        sqdb.orc.query(me.serviceUrl,me.json)
    }
    Form.prototype.setContext = function () {
        const me = this
        sq.setData(me.repeatDom, { "fields": me.context() })
        // if (me.record()) me.setRecord()
        return me
        //inject values if present?
    }

    Form.prototype.getRecord = function () {
        const me = this
        let ret = {}
        let fieldsDom = me.repeatDom.querySelectorAll("div.field")
        fieldsDom.forEach((dom) => {
            let field = dom.getAttribute('field')
            let value
            for (let type in me.context()[field].dataType) {
                let dataType = me.context()[field].dataType[type]
                let inputComponent = dataType.input.component
                // let formSpan = dom.querySelector
                let inputDom = dom.querySelector("span[name='input'] > *")
                //read context for special values?
                // switch (inputComponent) {
                    switch (type) {
                        case "boolean":
                            value = inputDom.checked
                            break;
                        case "object":
                            value = JSON.parse(inputDom.value==""?"{}":inputDom.value)
                            break;
                        case "array":
                            value = JSON.parse(inputDom.value==""?"[]":inputDom.value)
                            break;
                        default:
                            value = inputDom.value
                            break;
                    }
                    // let value = inputDom.type!=="checkbox"?inputDom.value:inputDom.checked
                ret[field] = value
                // }
            }
        })
        let getData = {}
        getData[me.id.value] = ret
        return getData
        //get record
        //check validity
        //return
    }

    Form.prototype.setRecord = function () {
        const me = this
        if (me.context() && me.repeatDom.innerHTML == "") me.setContext()
        for (let id in me._record) {
            me.id.value = id
            let rec = me._record[id]
            let map = me.context()
            for (let field in rec) {
                if (field !== "_meta") {
                    let value = rec[field]
                    // if (!value) debugger
                    let inputDom = me.repeatDom.querySelector('[field='+field+'] span[name="input"] > *')
                    if (inputDom) {
                        let context = map[field]
                        for (let type in context.dataType) {
                            let typeobj = context.dataType[type]
                            let inputComp = typeobj.input.component
                            switch (type) {
                                case "boolean":
                                    inputDom.checked = value
                                    break;
                                case "object":
                                    inputDom.value = JSON.stringify(value)
                                    break;
                                case "array":
                                    inputDom.value = JSON.stringify(value)
                                    break;
                                default:
                                    inputDom.value = value
                                    break;
                            }
                        }
                    }

                    //read context, check component
                }
            }
        }

    }

    Form.prototype.context = function (value) {
        const me = this
        if (value === undefined) return me._fields
        me._fields = value
        me.setContext()
        return me
    }

    Form.prototype.record = function (value) {
        const me = this
        if (value === undefined) return me._record
        me._record = value
        if (!me.context()) {
            let id = Object.keys(me._record)[0]
            let fields = me._record[id]._meta.tableInfo.fields
            me.context(fields)
        }
        me.setRecord(value)
        return me
    }
    Form.prototype.url = function (value) {
        const me = this
        if (value === undefined) return me.serviceUrl
        me.serviceUrl = value
        return me
    }
    Form.prototype.database = function (value) {
        const me = this
        if (value === undefined) return me.json.connection.database
        me.json.connection.database = value
        return me
    }
    Form.prototype.table = function (value) {
        const me = this
        if (value === undefined) return me.json.table
        me.json.table = value
        return me
    }
}