{
    const Response = sq.newComponent('sqdb:response');

    Response.prototype.init = function (dom) {
        const me = this;
        me.id = Orc.uid()
        me.serviceUrl = null
        me.__data__ = null
        me.json = {
            "connection": {
                "database": null,
                "credentials": {
                    "username": "sa",
                    "password": "sa"
                }
            },
            'table': null,
            'loadFields': true
        }
    }

    Response.prototype.load = function () {
        const me = this
        const sqdb = me.namespace
        sqdb.orc.on('query' + me.id, (response) => {
            me.__data__ = response
            me.dom.innerText = JSON.stringify(me.__data__)
        })
        me.query()

    }

    Response.prototype.query = function () {
        const me = this
        const sqdb = me.namespace
        sqdb.orc.post('clearInterval', [me.id])
        sqdb.orc.post('query', [me.serviceUrl, me.json, me.id])

    }

    Response.prototype.database = function (value) {
        const me = this
        if (value === undefined) return me.json.connection.database
        me.json.connection.database = value
        me.query()
        return me
    }

    Response.prototype.table = function (value) {
        const me = this
        if (value === undefined) return me.json.table
        me.json.table = value
        me.query()
        return me
    }

    Response.prototype.url = function (value) {
        const me = this
        if (value === undefined) return me.serviceUrl
        me.serviceUrl = value
        me.query()
        return me
    }

    Response.prototype.data = function (val) {
        let me = this
        if (val === undefined) return me.__data__
        return me
    }
}