importScripts('http://squid.sqreem.com/squidjs/20180219/engine/squidworkerbundle.js');
importScripts('http://squid.sqreem.com/squidjs/20180219/modules/orc/orc.js');


self.cache = {}
self.interval = {}

orc.query = function ([url, json, queryId = '']) {
    return sq.query(url, json).then(function (res) {
        let ret = self.updateData(queryId, res.data)
        if (ret) orc.trigger('query' + queryId, ret)
        return ret
    })
}

orc.queryInterval = function ([url, json, queryId = '', interval = '200000']) {
    interval[json.database + json.table] = setInterval(() => {
        orc.query([url, json, queryId])

    }, interval);
    return orc.query([url, json, queryId])
}

orc.clearInterval = function ([name]) {
    clearInterval(interval[name])
    return null
}

orc.getFields = function ([url, json, queryId = '']) {
    return sq.query(url, json).then(function (res) {
        let data = res.data
        let meta = data[Object.keys(data)[0]]._meta
        let fields = meta.tableInfo.fields
        for (let i in fields) {
            let field = fields[i]
            if (typeof field.dataType == "string") {
                let dtypestring = field.dataType
                field.dataType = self.cache.dataTypes[dtypestring]
            }
        }

        fields = self.getLookUp(fields, url, json)
        return fields
    })
}
orc.getDataTypes = function () {
    let query = {
        "table": "$datatype",
        "connection": {
            "serviceUrl": "http://tweets.sqreem.com:60064/data",
            "database": "universe",
            "credentials": {
                "username": "sa",
                "password": "sa"
            }
        },
        "limit": 500,
        "loadFields": true,
        "orderBy": [
            {
                "path": "$\\name"
            }
        ]
    }
    return orc.query([null, query]).then(function (resp) {
        self.cache.dataTypes = resp.data;
    })
}

self.updateData = function (context, data) {
    if (checkCache(context, data)) {
        updateCache(context, data)
        return parseData(data)
    }
    return null
}
self.checkCache = function (contextid, data) {
    let a = JSON.stringify(data)
    let b = JSON.stringify(cache[contextid])
    return !sq.compareObjects(a, b)
}
self.updateCache = function (id, data) {
    cache[id] = data
}
self.getLookUp = function (fields, url, json) {
    let stack = []
    Object.keys(fields).forEach((k) => {
        console.log(k)
        fields[k].inputType = fields[k].dataType
        if (fields[k].loadAsLookUp) {
            json.table = fields[k].lookUpTable
            json.loadMetaData = undefined
            console.log(JSON.parse(JSON.stringify(json)))
            let ps = sq.query(url, json).then((data) => {
                fields[k].options = parseOptions(data.data)
                fields[k].inputType = 'select'
            })
            stack.push(ps)
        }
    })
    return Promise.all(stack).then(() => {
        return fields
    })
}
self.parseOptions = function (data) {
    let newData = {}
    Object.keys(data).forEach((k) => {
        newData[k] = data[k].name
    })
    return newData
}
self.parseData = function (data) {
    return {
        'columns': getColumns(data),
        'data': getData(data)
    }
}
self.getColumns = function (data) {
    let cols = Object.keys(data[Object.keys(data)[0]])
    let ret = {}
    cols.forEach((col) => {
        ret[col] = {}
    })
    return ret
}
self.getData = function (data) {
    // Object.keys(data).forEach((k)=>{

    // })
    return data
}
