{
    const App = sq.newComponent('sqreem:app');
    let app = sq.ns.sqreem.session

    App.prototype.init = function () {
        const me = this;
    }

    App.prototype.load = function () {
        const me = this;

        console.clear()
        me.appbar = me.dom.querySelector('[name=bar]')
        me.userbtn = me.dom.querySelector('[name=userbtn]')
        me.chgpassbtn = me.dom.querySelector('[name=changepass]')
        me.signoutbtn = me.dom.querySelector('[name=logout]')
        
        me.logOrc = Orc.create('http://squid.sqreem.com/squidjs/20180326/extensions/sqreem/workers/sqreem-app.js?')
        // me.logOrc = Orc.create('sqreem-app.js?')

        me.logOrc.on('authApi', (resp) => {
            if (resp.success === 'True' && !resp.data.message) {
                let userData = resp.data[Object.keys(resp.data)[0]];
                if (!userData.accessToken) userData.accessToken = resp.data.accessToken
                activateApp.call(me, userData)
            }
            else {
                me.login.dom.setAttribute('stat', 'error');
                alert(msgs.autherr)
            }
        }).on('resetPassApi', (resp) => {
            if (resp.success === 'True' && resp.data.message === 'success') {
                me.login.dom.removeAttribute('stat');
                alert(msgs.resetpass)
            }
            else {
                me.login.dom.setAttribute('stat', 'error');
                alert(msgs.resetpasserr)
            }
        })

        me.userbtn.addEventListener('click', () => {
            if(me.dom.classList.contains('options')) me.dom.classList.remove('options')
            else me.dom.classList.add('options')
        });

        me.dom.addEventListener('click', (e) => {
            if (!e.target.closest("div[useropt]") && !e.target.closest("[name=userbtn]")) 
                me.dom.classList.remove('options');
        });

        me.chgpassbtn.addEventListener('click', () => {
            spawnPWModal.call(me)
        });

        me.signoutbtn.addEventListener('click', () => {
            if(confirm(msgs.outprompt)){
                stopCheckCookie.call(me).then(() => {
                    setTokenCookie.call(me, null, true)
                    location.reload(true)
                })
            }
        });
        checkActiveToken.call(me)
        app.__success__()
    }

    checkActiveToken = function () {
        const me = this;
        if (getTokenCookie())
            me.logOrc.post('authApi', [app.info.id, getTokenCookie()]);
        else {
            me.dom.setAttribute('auth', false);
            alert(msgs.loginprompt)
            spawnLogin.call(me)
        }
    }

    activateApp = function (userData) {
        const me = this;
        me.dom.setAttribute('auth', true)
        if(app.tempSession !== undefined) setTokenCookie.call(me, userData.accessToken)
        startCheckCookie.call(me)
        app.user = userData
        sq.setData(me.appbar, sq.ns.sqreem)
        setTitles()
        checkAppVersion.call(me)
        if(me.login) me.login.dom.remove()
        app.__userready__()
    }

    spawnLogin = function () {
        const me = this;
        me.dom.setAttribute('auth', '');
        setTokenCookie.call(me, null, true)
        sq.createComponent({
            namespace: "sq",
            component: "Login",
            attributes: {
                "title": "Sqreem Login - " + app.info.name,
                "subtitle": app.info.name,
                "image": app.info.img
            }
        }, me.dom).then((dom) => {
            me.login = dom.sq
            me.dom.setAttribute('auth', false);
            me.login.on('authenticate', (data) => {
                app.tempSession = !(data.keep);
                me.login.dom.setAttribute('stat', 'load')
                me.logOrc.post('authApi', [app.info.id, data.credentials])
            }).on('resetrequest', (data) => {
                me.login.dom.setAttribute('stat', 'load')
                me.logOrc.post('resetPassApi', [app.info.id, data])
            });
        });
    }

    spawnPWModal = function () {
        const me = this
        sq.createComponent({
            namespace: "sqreem",
            component: "pwmodal",
            attributes: {}
        }, me.dom).then((dom) => {
            dom.sq.on('requestchange', (password) => {
                me.logOrc.changePassApi(app.info.id, app.user.username, password).then((resp) => {
                    if (resp.data.success) {
                        stopCheckCookie.call(me).then(() => {
                            dom.remove()
                            alert(msgs.chgpass)
                            spawnLogin.call(me)
                        })
                    }
                    else alert(msgs.chgpasserr)
                })
            });
            dom.sq.modal.show()
        });
    }

    startCheckCookie = function () {
        const me = this
        let fx = 'initInterval'
        let first = true
        me.logOrc.post(fx, [])
        me.logOrc.on(fx, function(check) {
            if (check && first && !getTokenCookie()) {
                first = false
                stopCheckCookie.call(me).then(()=> {
                    app.__userexpire__()
                    alert(msgs.sessionexpire)
                    spawnLogin.call(me)
                })
            }
        })
    }

    getTokenCookie = function () {
        match = document.cookie.match(new RegExp('(^| )' + 'sqreem' + '=([^;]+)'));
        if (match) return match[2];
    }

    setTokenCookie = function (cvalue, todelete) {
        const me = this;
        let tempSession = app.tempSession
        me.logOrc.post('configureCookie', [cvalue, todelete, tempSession, app.version])
        me.logOrc.on('configureCookie', function(cookie) {
            document.cookie = cookie
        })
    }

    stopCheckCookie = function () {
        const me = this
        return me.logOrc.post('initInterval', [true])
    }

    setTitles = function () {
        document.title = app.info.name
        let link = document.querySelector("link[rel*='icon']") || document.createElement('link');
        link.type = 'image/x-icon';
        link.rel = 'shortcut icon';
        link.href = app.info.img;
        document.getElementsByTagName('head')[0].appendChild(link);
    }

    //temporary
    checkAppVersion = function () {
        const me = this
        let ver = localStorage.getItem("versions")
        let versions = ver ? JSON.parse(ver) : {};
        if (app.info.version !== versions[app.info.id]) {
            versions[app.info.id] = app.info.version
            sq.createComponent({
                namespace: "sqreem",
                component: "changelog",
                attributes: {
                    version: app.info.version
                }
            }, me.dom)
        }

        localStorage.setItem("versions", JSON.stringify(versions))
    }

    const msgs = {
        autherr: "Username not found or incorrect password.\nPlease verify your credentials.",
        apierr: "API Authentication Error:\n",
        chgpass: "Password successfully changed.\nPlease re-log in to continue your session.",
        chgpasserr: "Unable to change password.\nThe old password you have entered is incorrect.",
        resetpass: "Temporary password successfully sent to your e-mail.\nPlease change your password immediately after log-in.",
        resetpasserr: "Username and e-mail address combination not found in database.\nPlease verify your credentials",
        outprompt: "Are you sure you want to log out?\nNote: Any unsaved changes will be lost.",
        loginprompt: "Please login to continue...",
        sessionexpire: "Your session has expired. Please login again to continue."
    }

}