{
    const PWModal = sq.newComponent('sqreem:pwmodal');

    PWModal.prototype.init = function () {
        const me = this;
        me.addEvent('requestchange')
    }

    PWModal.prototype.load = function () {
        const me = this;
        me.form = me.dom.querySelector('form')
        me.modal = me.dom.querySelector('.sq.modal').sq
        let verifypass = me.dom.querySelector('[name=verifynew]')
        let submit = me.dom.querySelector('input[type=submit]')
        let changepass = me.dom.querySelector('[name=submit]')
        let cancel = me.dom.querySelector('[name=cancel]')

        clearFields.call(me)
    
        me.modal.onbeforeclose = function () {
            return confirm('Are you sure you want to cancel change password request?')
        }
        me.modal.on('close', () => { me.dom.remove() })
        
        verifypass.addEventListener('keyup', () => {
            let pw = sq.getData(me.form).password
            if (pw.new !== verifypass.value) {
                verifypass.setCustomValidity('Passwords do not match.')
                verifypass.classList.add('error')
            }
            else {
                verifypass.setCustomValidity('')
                verifypass.classList.remove('error')
            }
        });

        changepass.addEventListener('click', () => { submit.click() });
        me.form.addEventListener('submit', (e) => {
            e.preventDefault() 
            let pw = sq.getData(me.form).password
            me.trigger('requestchange', pw)
        })
        cancel.addEventListener('click', () => {
            clearFields.call(me)
            me.modal.close()
        });
    }

    let clearFields = function() {
        const me = this
        sq.setData(me.form, {
            password: {
                old: '',
                new: ''
            }
        })
    }

}