{
    const sqreem = new sq.Namespace("sqreem");
    sqreem.BaseComponent.prototype.message = function () { console.log("Sqreem basic components.") } 
    sqreem.loadComponents({ 
        "components": { 
            "app": [],
            "pwmodal": [],
            "changelog": []
        },
        "controllers": {}
    });

    Object.defineProperty(sqreem,'session',{
        enumerable:false,
        writable:false,
        value: {}
    })

    sqreem.session.onpagesuccess = new Promise(function (resolve, reject) {
        sqreem.session.__success__ = () => { resolve() }
    });

    sqreem.session.onuserready = new Promise(function (resolve, reject) {
        sqreem.session.__userready__ = () => { resolve() }
    });

    sqreem.session.onuserexpire = new Promise(function (resolve, reject) {
        sqreem.session.__userexpire__ = () => { resolve() }
    });

    sq.Component.prototype.serviceApi = function (serviceUrl, json) {
        let url;
        if (serviceUrl.match(/^(?:http(s)?:\/\/)?[\w.-]+(?:\.[\w\.-]+)+[\w\-\._~:\/?#[\]@!\$&'\(\)\*\+,;=.]+$/gm))
            url = serviceUrl
        else if (sqreem.app.apis[serviceUrl]) url = sqreem.app.apis[serviceUrl]
        else return console.warn(serviceUrl + ' is invalid. Verify if url exists on apis or if string is a valid url.')
        // let apiOrc = Orc.create('sqreem-app.js?')
        let apiOrc = Orc.create('http://squid.sqreem.com/squidjs/20180326/extensions/sqreem/workers/sqreem-app.js?')
        const appParams = {
            _app: sqreem.app.info.id,
            username: sqreem.app.user.username,
            accessToken: sqreem.app.user.accessToken
        }
        json = sq.mergeObjects(appParams, json)
        return apiOrc.post('postApi', [url, json])
    }
}