const SquidB = function () {
    const sqb = this;

    sqb.fs = require('fs')
    sqb.fse = require('fs-exta')
    sqb.path = require('path')
    sqb.__dirname = __dirname
    sqb.__dirproj = sqb.path.dirname(require.main.filename)

    sqb.getModule = function (source, target) {
        const me = this
        sqb.fs.copy(source, target, err => {
            if (err) return console.error(err)
            console.log('success!')
        })
    }

    sqb.readFile = function (source) {
        return sqb.fs.createReadStream(source)
    }

    sqb.appendFile = function (message, target) {
        let wr = sqb.fs.createWriteStream(target, {
            flags: 'a'
        })
        wr.write(message + "\n")
        wr.end()
    }

    sqb.copyFile = function (source, target, cb) {
        let cbCalled = false
        let rd = sqb.fs.createReadStream(source)
        let wr = sqb.fs.createWriteStream(target)

        rd.on("error", function (err) {
            done(err)
        })
        wr.on("error", function (err) {
            done(err)
        })
        wr.on("close", function (ex) {
            done()
        })
        rd.pipe(wr)

        function done(err) {
            if (!cbCalled) {
                cb(err)
                cbCalled = true
            }
        }
    }

    sqb.buildFile = function () {
        let dist = sqb.path.join(sqb.__dirproj, "release")
        let source = sqb.path.join(sqb.__dirname, "engine", "squid.js")
        let sq = sqb.path.join(sqb.__dirproj, "extensions", "sq")
        let target = sqb.path.join(dist, "squid.js")
        sqb.fs.mkdir(dist, '0755', function () {
            console.log('Creating distribution folder..')
        })
        sqb.copyFile(source, target, function (err) {
            if (err) console.log(err)
            else console.log("Squid application builded..")
        })
    }

}

module.exports = new SquidB()